#!/bin/csh -f

echo "########################################################################"
echo "### Generating public and private key files                          ###" 
echo "########################################################################"
preprocessverilog -generate_keys
\rm -rf VlogPP
echo "########################################################################"
echo "### Encrypting the input verilog file with the public key             ##"
echo "########################################################################"
preprocessverilog -in test.v -public_key_file key.pub.dat -encryption_key eda_utils_dot_com
mv VlogPP/test.v temp.v
echo "########################################################################"
echo "### Decrypting the encrypted input verilog file with the private key  ##"
echo "########################################################################"
preprocessverilog -in temp.v -private_key_file key.pvt.dat


echo "########################################################################"
echo "########################################################################"
echo "###                Finished this example                             ###"
echo "########################################################################"
echo "########################################################################"
