// TJC implementation of procedure compileproc_container_catch_handler_var
package tjc;
import tcl.lang.*;

public class CompileprocContainerCatchHandlerVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol is_empty_body setvar_buffer");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "is_empty_body", objv[2], compiledLocals, 1);
        setVarScalar(interp, "setvar_buffer", objv[3], compiledLocals, 2);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {!$is_empty_body} ...
            // Unary operator: ! $is_empty_body
            TclObject tmp0 = getVarScalar(interp, "is_empty_body", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: append buffer [...] ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv5 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv5[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv5, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv5, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp4 = interp.getResult();
                        tmp4.preserve();
                        objv3[0] = tmp4;
                        // Arg 3 constant: ...
                        objv3[1] = const2;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv3, compiledLocals, 3);
                    } finally {
                        tmp4 = objv3[0];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] ...
            TclObject[] objv6 = TJC.grabObjv(interp, 2);
            TclObject tmp7;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv8 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv8[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv8, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv8, 1);
                    }
                } // End Invoke: emitter_indent
                tmp7 = interp.getResult();
                tmp7.preserve();
                objv6[0] = tmp7;
                // Arg 3 constant: ...
                objv6[1] = const3;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv6, compiledLocals, 3);
            } finally {
                tmp7 = objv6[0];
                if ( tmp7 != null ) {
                    tmp7.release();
                }
                TJC.releaseObjv(interp, objv6, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv9 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv9[0] = const4;
                // Arg 1 constant: +1
                objv9[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv9, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv9, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            // Binary operator: $setvar_buffer == ""
            TclObject tmp10 = getVarScalar(interp, "setvar_buffer", compiledLocals, 2);
            ExprValue tmp11 = evs0;
            TJC.exprEqualsEmptyString(tmp11, tmp10, false);
            // End Binary operator: ==
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: error ...
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv13[0] = const6;
                        // Arg 1 constant: ...
                        objv13[1] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv13, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: append buffer $setvar_buffer
            TclObject[] objv14 = TJC.grabObjv(interp, 1);
            TclObject tmp15;
            try {
                // Arg 2 variable: $setvar_buffer
                tmp15 = getVarScalar(interp, "setvar_buffer", compiledLocals, 2);
                tmp15.preserve();
                objv14[0] = tmp15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv14, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv14, 1);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv16 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv16[0] = const4;
                // Arg 1 constant: -1
                objv16[1] = const8;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv16, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv16, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv17 = TJC.grabObjv(interp, 2);
            TclObject tmp18;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv19 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv19[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv19, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv19, 1);
                    }
                } // End Invoke: emitter_indent
                tmp18 = interp.getResult();
                tmp18.preserve();
                objv17[0] = tmp18;
                // Arg 3 constant: ...
                objv17[1] = const9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv17, compiledLocals, 3);
            } finally {
                tmp18 = objv17[0];
                if ( tmp18 != null ) {
                    tmp18.release();
                }
                TJC.releaseObjv(interp, objv17, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv20 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv20[0] = const4;
                // Arg 1 constant: +1
                objv20[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv20, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv20, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv21 = TJC.grabObjv(interp, 2);
            TclObject tmp22;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv23 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv23[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv23, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv23, 1);
                    }
                } // End Invoke: emitter_indent
                tmp22 = interp.getResult();
                tmp22.preserve();
                objv21[0] = tmp22;
                // Arg 3 constant: ...
                objv21[1] = const10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv21, compiledLocals, 3);
            } finally {
                tmp22 = objv21[0];
                if ( tmp22 != null ) {
                    tmp22.release();
                }
                TJC.releaseObjv(interp, objv21, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv24 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv24[0] = const4;
                // Arg 1 constant: -1
                objv24[1] = const8;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv24, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv24, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv25 = TJC.grabObjv(interp, 2);
            TclObject tmp26;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv27 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv27[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv27, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv27, 1);
                    }
                } // End Invoke: emitter_indent
                tmp26 = interp.getResult();
                tmp26.preserve();
                objv25[0] = tmp26;
                // Arg 3 constant: ...
                objv25[1] = const11;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv25, compiledLocals, 3);
            } finally {
                tmp26 = objv25[0];
                if ( tmp26 != null ) {
                    tmp26.release();
                }
                TJC.releaseObjv(interp, objv25, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv28 = TJC.grabObjv(interp, 1);
            TclObject tmp29;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_reset_result
                    TclObject[] objv30 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_reset_result
                        objv30[0] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv30, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv30, 1);
                    }
                } // End Invoke: emitter_reset_result
                tmp29 = interp.getResult();
                tmp29.preserve();
                objv28[0] = tmp29;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv28, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv28, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$is_empty_body} ... else ...
            TclObject tmp31 = getVarScalar(interp, "is_empty_body", compiledLocals, 1);
            boolean tmp32 = TJC.getBoolean(interp, tmp31);
            if ( tmp32 ) {
                { // Invoke: append buffer [...] ...
                    TclObject[] objv33 = TJC.grabObjv(interp, 2);
                    TclObject tmp34;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv35 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv35[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv35, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv35, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp34 = interp.getResult();
                        tmp34.preserve();
                        objv33[0] = tmp34;
                        // Arg 3 constant: ...
                        objv33[1] = const13;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv33, compiledLocals, 3);
                    } finally {
                        tmp34 = objv33[0];
                        if ( tmp34 != null ) {
                            tmp34.release();
                        }
                        TJC.releaseObjv(interp, objv33, 2);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer [...] "interp.setResult(" $tmpsymbol ...
                    TclObject[] objv36 = TJC.grabObjv(interp, 4);
                    TclObject tmp37;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv38 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv38[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv38, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv38, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp37 = interp.getResult();
                        tmp37.preserve();
                        objv36[0] = tmp37;
                        // Arg 3 constant: "interp.setResult("
                        objv36[1] = const14;
                        // Arg 4 variable: $tmpsymbol
                        tmp37 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                        tmp37.preserve();
                        objv36[2] = tmp37;
                        // Arg 5 constant: ...
                        objv36[3] = const15;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv36, compiledLocals, 3);
                    } finally {
                        tmp37 = objv36[0];
                        if ( tmp37 != null ) {
                            tmp37.release();
                        }
                        tmp37 = objv36[2];
                        if ( tmp37 != null ) {
                            tmp37.release();
                        }
                        TJC.releaseObjv(interp, objv36, 4);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp39 = getVarScalar(interp, "buffer", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp39);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_container_catch_handler_var");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("TclObject result = interp.getResult();\n");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("try {\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent_level");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("+1");
        TclInteger.get(interp, const5);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("error");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("setvar buffer should not be empty");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(-1);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("} catch (TclException ex) {\n");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("TJC.catchVarErr(interp);\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("}\n");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_reset_result");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("interp.setResult(TCL.OK);\n");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("interp.setResult(");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(");\n");
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "emitter_reset_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "is_empty_body",
        "setvar_buffer",
        "buffer"
    };
} // end class CompileprocContainerCatchHandlerVarCmd

