// TJC implementation of procedure _parseproc_append_outscript_up_to
package tjc;
import tcl.lang.*;

public class ParseprocAppendOutscriptUpToCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "range");
        }
        setVarScalar(interp, "range", objv[1], compiledLocals, 0);
        { // Invoke: global _parseproc
            TJC.makeGlobalLinkVar(interp, "_parseproc", "_parseproc", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("_parseproc_append_outscript_to ");
                        sbtmp4.append("{");
                        tmp3 = getVarScalar(interp, "range", compiledLocals, 0);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append("}");
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set inscript $...
            TclObject tmp5;
            tmp5 = getVarArray(interp, "_parseproc", "inscript", compiledLocals, 1);
            setVarScalar(interp, "inscript", tmp5, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set inscript_start [...]
            TclObject tmp6;
            { // Invoke: lindex $... 0
                TclObject tmp7 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 1);
                tmp7 = TclList.index(interp, tmp7, 0);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "inscript_start", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $inscript_start != 0
            TclObject tmp8 = getVarScalar(interp, "inscript_start", compiledLocals, 4);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp9, tmp10);
            // End Binary operator: !=
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("expected inscript_start to be 0, got ");
                        tmp13 = getVarScalar(interp, "inscript_start", compiledLocals, 4);
                        sbtmp14.append(tmp13.toString());
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set inscript_len [...]
            TclObject tmp15;
            { // Invoke: lindex $... 1
                TclObject tmp16 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 1);
                tmp16 = TclList.index(interp, tmp16, 1);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            tmp15 = interp.getResult();
            setVarScalar(interp, "inscript_len", tmp15, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set range_start [...]
            TclObject tmp17;
            { // Invoke: lindex $range 0
                TclObject tmp18 = getVarScalar(interp, "range", compiledLocals, 0);
                tmp18 = TclList.index(interp, tmp18, 0);
                if ( tmp18 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp18);
                }
            } // End Invoke: lindex
            tmp17 = interp.getResult();
            setVarScalar(interp, "range_start", tmp17, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set range_len [...]
            TclObject tmp19;
            { // Invoke: lindex $range 1
                TclObject tmp20 = getVarScalar(interp, "range", compiledLocals, 0);
                tmp20 = TclList.index(interp, tmp20, 1);
                if ( tmp20 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp20);
                }
            } // End Invoke: lindex
            tmp19 = interp.getResult();
            setVarScalar(interp, "range_len", tmp19, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set before_len [...]
            TclObject tmp21;
            { // Invoke: expr ...
                // Binary operator: $range_start - $inscript_len
                TclObject tmp22 = getVarScalar(interp, "range_start", compiledLocals, 6);
                ExprValue tmp23 = evs0;
                TJC.exprInitValue(interp, tmp23, tmp22);
                TclObject tmp24 = getVarScalar(interp, "inscript_len", compiledLocals, 5);
                ExprValue tmp25 = evs1;
                TJC.exprInitValue(interp, tmp25, tmp24);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp23, tmp25);
                // End Binary operator: -
                TJC.exprSetResult(interp, tmp23);
            } // End Invoke: expr
            tmp21 = interp.getResult();
            setVarScalar(interp, "before_len", tmp21, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if {$before_len > 0} ...
            // Binary operator: $before_len > 0
            TclObject tmp26 = getVarScalar(interp, "before_len", compiledLocals, 8);
            ExprValue tmp27 = evs0;
            TJC.exprInitValue(interp, tmp27, tmp26);
            ExprValue tmp28 = evs1;
            tmp28.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp27, tmp28);
            // End Binary operator: >
            boolean tmp29 = ( tmp27.getIntValue() != 0 );
            if ( tmp29 ) {
                { // Invoke: set range_before [...]
                    TclObject tmp30;
                    { // Invoke: list $inscript_len $before_len
                        TclObject tmp31 = TclList.newInstance();
                        TclObject tmp32;
                        try {
                            tmp32 = getVarScalar(interp, "inscript_len", compiledLocals, 5);
                            TclList.append(interp, tmp31, tmp32);
                            tmp32 = getVarScalar(interp, "before_len", compiledLocals, 8);
                            TclList.append(interp, tmp31, tmp32);
                        } catch (TclException ex) {
                            tmp31.release();
                            throw ex;
                        }
                        interp.setResult(tmp31);
                    } // End Invoke: list
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "range_before", tmp30, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set range_before_string [...]
                    TclObject tmp33;
                    { // Invoke: parse getstring $... $range_before
                        TclObject[] objv34 = TJC.grabObjv(interp, 4);
                        TclObject tmp35;
                        try {
                            // Arg 0 constant: parse
                            objv34[0] = const3;
                            // Arg 1 constant: getstring
                            objv34[1] = const4;
                            // Arg 2 variable: $...
                            tmp35 = getVarArray(interp, "_parseproc", "inscript", compiledLocals, 1);
                            tmp35.preserve();
                            objv34[2] = tmp35;
                            // Arg 3 variable: $range_before
                            tmp35 = getVarScalar(interp, "range_before", compiledLocals, 9);
                            tmp35.preserve();
                            objv34[3] = tmp35;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv34, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp35 = objv34[2];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            tmp35 = objv34[3];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            TJC.releaseObjv(interp, objv34, 4);
                        }
                    } // End Invoke: parse
                    tmp33 = interp.getResult();
                    setVarScalar(interp, "range_before_string", tmp33, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: append ... $range_before_string
                    TclObject[] objv36 = TJC.grabObjv(interp, 1);
                    TclObject tmp37;
                    try {
                        // Arg 2 variable: $range_before_string
                        tmp37 = getVarScalar(interp, "range_before_string", compiledLocals, 10);
                        tmp37.preserve();
                        objv36[0] = tmp37;
                        interp.resetResult();
                        appendVarArray(interp, "_parseproc", "outscript", objv36, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv36, 1);
                    }
                } // End Invoke: append
                { // Invoke: if {$debug} ...
                    TclObject tmp38 = getVarScalar(interp, "debug", compiledLocals, 2);
                    boolean tmp39 = TJC.getBoolean(interp, tmp38);
                    if ( tmp39 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv40 = TJC.grabObjv(interp, 2);
                            TclObject tmp41;
                            try {
                                // Arg 0 constant: puts
                                objv40[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp42 = new StringBuffer(64);
                                sbtmp42.append("range_before is ");
                                sbtmp42.append("{");
                                tmp41 = getVarScalar(interp, "range_before", compiledLocals, 9);
                                sbtmp42.append(tmp41.toString());
                                sbtmp42.append("}");
                                tmp41 = TclString.newInstance(sbtmp42);
                                tmp41.preserve();
                                objv40[1] = tmp41;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv40, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp41 = objv40[1];
                                if ( tmp41 != null ) {
                                    tmp41.release();
                                }
                                TJC.releaseObjv(interp, objv40, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: puts "..."
                            TclObject[] objv43 = TJC.grabObjv(interp, 2);
                            TclObject tmp44;
                            try {
                                // Arg 0 constant: puts
                                objv43[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp45 = new StringBuffer(64);
                                sbtmp45.append("range_before_string is ");
                                sbtmp45.append("\"");
                                tmp44 = getVarScalar(interp, "range_before_string", compiledLocals, 10);
                                sbtmp45.append(tmp44.toString());
                                sbtmp45.append("\"");
                                tmp44 = TclString.newInstance(sbtmp45);
                                tmp44.preserve();
                                objv43[1] = tmp44;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv43, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp44 = objv43[1];
                                if ( tmp44 != null ) {
                                    tmp44.release();
                                }
                                TJC.releaseObjv(interp, objv43, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp46;
            { // Invoke: list $inscript_start $range_start
                TclObject tmp47 = TclList.newInstance();
                TclObject tmp48;
                try {
                    tmp48 = getVarScalar(interp, "inscript_start", compiledLocals, 4);
                    TclList.append(interp, tmp47, tmp48);
                    tmp48 = getVarScalar(interp, "range_start", compiledLocals, 6);
                    TclList.append(interp, tmp47, tmp48);
                } catch (TclException ex) {
                    tmp47.release();
                    throw ex;
                }
                interp.setResult(tmp47);
            } // End Invoke: list
            tmp46 = interp.getResult();
            setVarArray(interp, "_parseproc", "inscript_range", tmp46, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp49 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp50 = TJC.getBoolean(interp, tmp49);
            if ( tmp50 ) {
                { // Invoke: puts "..."
                    TclObject[] objv51 = TJC.grabObjv(interp, 2);
                    TclObject tmp52;
                    try {
                        // Arg 0 constant: puts
                        objv51[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp53 = new StringBuffer(64);
                        sbtmp53.append("prev inscript_range is ");
                        sbtmp53.append("{");
                        tmp52 = getVarScalar(interp, "inscript_start", compiledLocals, 4);
                        sbtmp53.append(tmp52.toString());
                        sbtmp53.append(" ");
                        tmp52 = getVarScalar(interp, "inscript_len", compiledLocals, 5);
                        sbtmp53.append(tmp52.toString());
                        sbtmp53.append("}");
                        tmp52 = TclString.newInstance(sbtmp53);
                        tmp52.preserve();
                        objv51[1] = tmp52;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv51, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp52 = objv51[1];
                        if ( tmp52 != null ) {
                            tmp52.release();
                        }
                        TJC.releaseObjv(interp, objv51, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv54 = TJC.grabObjv(interp, 2);
                    TclObject tmp55;
                    try {
                        // Arg 0 constant: puts
                        objv54[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp56 = new StringBuffer(64);
                        sbtmp56.append("command range is ");
                        sbtmp56.append("{");
                        tmp55 = getVarScalar(interp, "range_start", compiledLocals, 6);
                        sbtmp56.append(tmp55.toString());
                        sbtmp56.append(" ");
                        tmp55 = getVarScalar(interp, "range_len", compiledLocals, 7);
                        sbtmp56.append(tmp55.toString());
                        sbtmp56.append("}");
                        tmp55 = TclString.newInstance(sbtmp56);
                        tmp55.preserve();
                        objv54[1] = tmp55;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv54, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp55 = objv54[1];
                        if ( tmp55 != null ) {
                            tmp55.release();
                        }
                        TJC.releaseObjv(interp, objv54, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv57 = TJC.grabObjv(interp, 2);
                    TclObject tmp58;
                    try {
                        // Arg 0 constant: puts
                        objv57[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp59 = new StringBuffer(64);
                        sbtmp59.append("command string is ");
                        sbtmp59.append("\"");
                        { // Invoke: parse getstring $... [...]
                            TclObject[] objv60 = TJC.grabObjv(interp, 4);
                            TclObject tmp61;
                            try {
                                // Arg 0 constant: parse
                                objv60[0] = const3;
                                // Arg 1 constant: getstring
                                objv60[1] = const4;
                                // Arg 2 variable: $...
                                tmp61 = getVarArray(interp, "_parseproc", "inscript", compiledLocals, 1);
                                tmp61.preserve();
                                objv60[2] = tmp61;
                                // Arg 3 command: [...]
                                { // Invoke: list $range_start $range_len
                                    TclObject tmp62 = TclList.newInstance();
                                    TclObject tmp63;
                                    try {
                                        tmp63 = getVarScalar(interp, "range_start", compiledLocals, 6);
                                        TclList.append(interp, tmp62, tmp63);
                                        tmp63 = getVarScalar(interp, "range_len", compiledLocals, 7);
                                        TclList.append(interp, tmp62, tmp63);
                                    } catch (TclException ex) {
                                        tmp62.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp62);
                                } // End Invoke: list
                                tmp61 = interp.getResult();
                                tmp61.preserve();
                                objv60[3] = tmp61;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv60, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp61 = objv60[2];
                                if ( tmp61 != null ) {
                                    tmp61.release();
                                }
                                tmp61 = objv60[3];
                                if ( tmp61 != null ) {
                                    tmp61.release();
                                }
                                TJC.releaseObjv(interp, objv60, 4);
                            }
                        } // End Invoke: parse
                        tmp58 = interp.getResult();
                        sbtmp59.append(tmp58.toString());
                        sbtmp59.append("\"");
                        tmp58 = TclString.newInstance(sbtmp59);
                        tmp58.preserve();
                        objv57[1] = tmp58;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv57, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp58 = objv57[1];
                        if ( tmp58 != null ) {
                            tmp58.release();
                        }
                        TJC.releaseObjv(interp, objv57, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv64 = TJC.grabObjv(interp, 2);
                    TclObject tmp65;
                    try {
                        // Arg 0 constant: puts
                        objv64[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp66 = new StringBuffer(64);
                        sbtmp66.append("new outscript is ");
                        sbtmp66.append("\"");
                        tmp65 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 1);
                        sbtmp66.append(tmp65.toString());
                        sbtmp66.append("\"");
                        tmp65 = TclString.newInstance(sbtmp66);
                        tmp65.preserve();
                        objv64[1] = tmp65;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv64, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp65 = objv64[1];
                        if ( tmp65 != null ) {
                            tmp65.release();
                        }
                        TJC.releaseObjv(interp, objv64, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv67 = TJC.grabObjv(interp, 2);
                    TclObject tmp68;
                    try {
                        // Arg 0 constant: puts
                        objv67[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp69 = new StringBuffer(64);
                        sbtmp69.append("new inscript_range is ");
                        sbtmp69.append("{");
                        tmp68 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 1);
                        sbtmp69.append(tmp68.toString());
                        sbtmp69.append("}");
                        tmp68 = TclString.newInstance(sbtmp69);
                        tmp68.preserve();
                        objv67[1] = tmp68;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv67, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp68 = objv67[1];
                        if ( tmp68 != null ) {
                            tmp68.release();
                        }
                        TJC.releaseObjv(interp, objv67, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parseproc_append_outscript_up_to");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("getstring");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "range",
        "_parseproc",
        "debug",
        "inscript",
        "inscript_start",
        "inscript_len",
        "range_start",
        "range_len",
        "before_len",
        "range_before",
        "range_before_string"
    };
} // end class ParseprocAppendOutscriptUpToCmd

